<?
  /* PHPix photo album
   * Copyright (C) 2001 Neale Pickett <neale@woozle.org>
   * Copyright (C) 2000 Robert A. Holak <conefish@sourceforge.net>
   *
   * This program is free software; you can redistribute it and/or
   * modify it under the terms of the GNU General Public License as
   * published by the Free Software Foundation; either version 2 of
   * the License, or (at your option) any later version.
   *
   * This program is distributed in the hope that it will be useful,
   * but WITHOUT ANY WARRANTY; without even the implied warranty of
   * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   * GNU General Public License for more details.
   *
   * You should have received a copy of the GNU General Public License
   * along with this program; if not, write to the Free Software
   * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   * 02111-1307  USA
   */
$version = "2.0.1";
include("config.inc");

## This is stuff they all need to do
preg_match("/(.*\/).*$/",$SCRIPT_FILENAME,$matches);
chdir($matches[1]);

preg_match("/(.*\/).*$/",$SCRIPT_NAME,$htmlmatches);

# set up the variables for user = use this way we can change the method of
# getting the user var and won't have to change the code much. 

#variables:
# $scriptbase -> where the script is. (includes /)
# $realpixbase -> Where the pics are (includes /)
# $realdescbase -> Where the descs are (includes /)
# $userbase -> the user's public html dir (includes /)
# $htmlbase -> the scripts html base. (includes /)
# $htmluserbase -> the user's html base. (includes /)
# $username -> the username of the user we're accessing.
# $userstring -> how we pass on the username.
# $usercachebase -> Where in the cache the images are located.

$scriptbase = "$matches[1]";
$realpixbase = $scriptbase.$pix_base."/";
$realdescbase = $scriptbase.$desc_base."/";
$userbase = "$scriptbase";
$htmlbase = "$htmlmatches[1]";
$htmluserbase = "$htmlmatches[1]";
$username = "";
$userstring = "?";
$usercachebase = "";

if ($enable_users) {
  if ($PATH_INFO != '') {
    $user = substr($PATH_INFO, 1);
  }

  if ($user != '') {
    # Turn off error reporting, we don't care if the username doesn't exist
    $error = error_reporting(0);
    
    $userinfo = posix_getpwnam($user);
    
    error_reporting($error);

    if ($userinfo['uid'] > 100) {
      $userbase = $userinfo['dir']."/".$public_html."/";
      $realpixbase = $userbase.$pix_base."/";
      $htmluserbase = "/~${user}/";
      $username = $user;
      $userstring = "/${username}?";
      $usercachebase = "${username}/";
    }
  }
}

if ($dispsize == '') $dispsize = $default_size;
if ($start == '') $start = 0;

if (preg_match("/(^|\/)\.\.(\/|$)/", $album)) {
  # Never attribute to malice what can be adequately explained by
  # stupidity.
  $album = "";
}
if (preg_match("/(^|\/)\.\.(\/|$)/", $pic)) {
  $pic = "";
}

  # Get a list of filenames

  if (file_exists($realpixbase.$album)) {
    
    $configoverride = FindFileDownPath($realpixbase.$album, ".config",
                                       $realpixbase.$album);

    if ($configoverride) {
      include($configoverride);
    }

    $handle=opendir($realpixbase.$album);


    while (($file = readdir($handle)) != '') {
      if (!ereg("^\.", basename($file))) {
        if (is_dir($realpixbase.$album."/".$file)) {
          if (($file != ".") and ($file != "..")) {
            $dirlist[] = $file;
          }
        } else {
          if (($file != "style.css") && (! strstr($file, "__desc.txt"))) {
            $filelist[] = $file;
          }
        }
      }
    }

    $stylesheet = FindFileDownPath($realpixbase.$album, "style.css",
                                   $realpixbase);

    if ($userbase != "") {
      $stylesheet = str_replace($userbase, "", $stylesheet);

      # may be kludgy.
      if ($stylesheet[0] == '/') {
        $stylesheet = "";
      }
    }
    if ($stylesheet != '') {
      $stylesheet = $htmluserbase.urlencode_url($stylesheet);
    }
  }

  if (is_array($dirlist)) { sort($dirlist); }
  if (is_array($filelist)) {
    sort($filelist); 
    $totalfiles = sizeof($filelist);
  } else {
    $totalfiles = 0;
  }


function FindFileDownPath($path, $filename, $stop) {
  $filepath = $path;
  $returned = "";
  $stopped = 0;


  while (($pos = strrpos($filepath, "/")) && !$stopped) {
    # print "$pos - $filepath - $filename - $stop<BR>";
    if (file_exists($filepath."/".$filename)) {
      $returned = $filepath."/".$filename;
      $stopped = 1;
    }
    if ($filepath."/" == $stop) {
      $stopped = 1;
      # print "Stopped - $filepath - $stop<BR>";
    }
    $filepath = substr($filepath, 0, $pos); 
  }
  return $returned;
}

## Encode a string without escaping /
function urlencode_url($path) {
	$parts = split("/", $path);
	reset($parts);
	while (list(, $dirname) = each($parts)) {
	  $url .= "/" . rawurlencode($dirname);
	}
	return substr($url, 1);
}


$colcounter = 0;

function DisplayImage($href, $src, $width=0, $height=0, $desc=0, $class='body', $top_text='') {
  global $colcounter;
  global $display_cols;

  if ($colcounter == $display_cols) {
    print "</tr><tr class='$class'>\n";
    $colcounter = 0;
  }

  print "<td class='$class'>\n";
  if ($top_text) {
    if ($href) {
      print "<a href='$href' class='$class-desc'>";
    }
    print $top_text;
    if ($href) {
      print "</a>\n";
    }
    print "<br>\n";
  }
  if ($src) {
    if ($href) {
      print "<a href='$href' class='$class-pic'>";
    }
    print "<img class='$class-pic'"; 
    if ($width) { print " width='$width'"; }
    if ($height) { print " height='$height'"; }
    print " alt='" . htmlentities($desc,ENT_QUOTES) . "'";
    print " src='$src'>"; 
    if ($href) {
      print "</a>\n";
    }
    print "<br>\n";
  }
  if ($desc) {
    if ($href) {
      print "<a href='$href' class='$class-desc'>";
    }
    print htmlentities($desc,ENT_QUOTES);
    if ($href) {
      print "</a>\n";
    }
  }
  print "</td>\n";
  $colcounter += 1;
}

function PadTable($class="") {
  global $colcounter;
  global $display_cols;
  global $thumb_size;

  while ($colcounter != $display_cols) {
    print "<td class='$class'>\n";
    print "<img class='pic' width='$thumb_size' height='1' src='blank.gif' alt=''>\n";
    print "</td>\n";
    $colcounter += 1;
  }
  $colcounter = 0;
  print "</tr>\n";
}

# Checks directory existence along $pathname and create them as necessary
# Not sure if it's not over complicated
function checkdir($pathname) {
	$darray = split("/",$pathname);
	$chckdir = $darray[0];
	for ($x=1; $x<sizeof($darray); $x++) {
		$chckdir = $chckdir . "/" . $darray[$x];
		if (!file_exists($chckdir)) { 
			mkdir($chckdir,0775); 
		}
	}
}

# XXX: Have this display some notice that it's doing something

function CreateImage($size,$source,$dest) {
	$sourcedate = 0;
	$destdate = 0;
	global $convert;
	global $album;
	global $cache_base;
        global $username;

	if (file_exists($dest)) {
		clearstatcache();
		$sourceinfo = stat($source);
		$destinfo = stat($dest);
		$sourcedate = $sourceinfo[10];
		$destdate = $destinfo[10];
	}
	if (!file_exists("$dest") or ($sourcedate > $destdate)) {
		global $ImageTool;
		$imgsize = GetImageSize($source);
		$width = $imgsize[0];
		$height = $imgsize[1];

		if ($width == 0) {
			# Can't really scale a zero-width image...
			# XXX: have this display an icon for the file type
			return -1;
		}

		if ($width > $height) {
			$new_width = $size;
			$new_height = ceil($size * $height / $width);
		} else {
			$new_height = $size;
			$new_width = ceil($size * $width / $height);
		}
		if ($ImageTool == "int") {
			if (preg_match("/\.jp(g|eg)$/i",$source)) {
				# disable errors in case of invalid image
				$error = error_reporting(0);
				$im = ImageCreateFromJPEG($source);
				error_reporting($error);
				if (!$im) {
					# problem reading the file
					return -1;
				}
				$new_im = ImageCreate($new_width,$new_height);
	
				ImageCopyResized($new_im,$im,0,0,0,0,$new_width,$new_height,ImageSX($im),ImageSY($im));

				# Check if the directories are there
				checkdir("$cache_base/$username/$album");
			
				ImageJPEG($new_im,$dest,75);
			} elseif (preg_match("/\.gif$/i",$source)) {
				# disable errors in case of invalid image
				$error = error_reporting(0);
				$im = ImageCreateFromGIF($source);
				error_reporting($error);
				if (!$im) {
					# problem reading the file
					return -1;
				}
				$new_im = ImageCreate($new_width,$new_height);
	
				ImageCopyResized($new_im,$im,0,0,0,0,$new_width,$new_height,ImageSX($im),ImageSY($im));

				# Check if the directories are there
				checkdir("$cache_base/$username/$album");
			
				ImageJPEG($new_im,$dest,75);
			} elseif (preg_match("/\.png$/i",$source)) {
				# disable errors in case of invalid image
				$error = error_reporting(0);
				$im = ImageCreateFromPNG($source);
				error_reporting($error);
				if (!$im) {
					# problem reading the file
					return -1;
				}
				$new_im = ImageCreate($new_width,$new_height);
	
				ImageCopyResized($new_im,$im,0,0,0,0,$new_width,$new_height,ImageSX($im),ImageSY($im));

				# Check if the directories are there
				checkdir("$cache_base/$username/$album");
			
				ImageJPEG($new_im,$dest,75);
			} else {
				return -1;
			}
		} elseif ($ImageTool == "ext") {
			if ($username != '') {
				$newalbum = $username."/".$album;
			} else {
				$newalbum = $album;
			}
			system("$convert $new_width $new_height \"$cache_base\" \"$newalbum\" \"$source\" \"$dest\" 2>&1");
		}

		if (!file_exists($dest)) {
			return -1;
		}
	}
}

function NavBar($mode,$path,$start) {
	$endpoint = basename($path);
	global $dispsize;
	global $sitehome;
	global $albumpath;
    global $show_albums;
    global $userstring;
    global $htmlbase;

	if ($sitehome != '') {
		print "<a href='$sitehome' class='navbar' id='home'>Home</a>\n";
	}

    if ($show_albums != 0) {
        if ($sitehome != '') { print " &gt; "; }
        print "<a href='${htmlbase}${albumpath}${userstring}dispsize=$dispsize' class='navbar' id='albums'>Albums</a>\n";
    }
	$doo = split("/",$path);
	$prepath = '';
	$st = 0;
	while (list($foo,$filename) = each($doo)) {
		if ($filename) {
			if ($prepath) {
				$fullname = $prepath . "/" . $filename;
			} else {
				$fullname = $filename;
			}
			print " &gt; ";
			if ($filename == $endpoint) {
				print "<span class='endpoint'>";
				$st = $start;
			}
			print "<a href='${htmlbase}${albumpath}${userstring}album=" . urlencode($fullname) . "&amp;dispsize=$dispsize&amp;start=$st' class='navbar' id='dir'>$filename</a>";
			if ($filename == $endpoint) {
				print "</span>";
			}
			print "\n";
			$prepath = $fullname;
		}
	}
}

function StandardLinks($mode,$path,$start,$picindex="") {
	$endpoint = basename("/" . $path);
	global $dispsize;
	global $sitehome;
	global $albumpath;
    global $show_albums;
    global $userstring;
    global $htmlbase;
    global $filelist;
    global $viewpath;
    global $items_per_page;
    global $totalfiles;

	if ($sitehome != '') {
		print "<link rev='home' type='text/html' href='$sitehome'>\n";
	}

    if ($show_albums != 0) {
        print "<link rel='toc' type='text/html' href='${htmlbase}${albumpath}${userstring}dispsize=$dispsize'>\n";
    }
    
	if ($mode == "view") {
		print "<link rev='up' type='text/html' href='${htmlbase}${albumpath}${userstring}album=" . urlencode($path) . "&amp;dispsize=$dispsize&amp;start=$st'>\n";
		
		$start_url = $htmlbase.$viewpath.$userstring."album=" . urlencode($path) . "&amp;pic=" . urlencode($filelist[0]) . "&amp;dispsize=$dispsize&amp;start=$start&amp;picindex=0";
		print "<link rev='first' type='text/html' href='$start_url'>\n";
		
		if ($filelist[($picindex-1)]) {
			$prev_url = $htmlbase.$viewpath.$userstring."album=" . urlencode($path) . "&amp;pic=" . urlencode($filelist[$picindex-1]) . "&amp;dispsize=$dispsize&amp;start=$start&amp;picindex=" . ($picindex - 1);
			print "<link rev='prev' type='text/html' href='$prev_url'>\n";
		}
		
		if ($filelist[($picindex+1)]) {
			$next_url = $htmlbase.$viewpath.$userstring."album=" . urlencode($path) . "&amp;pic=" . urlencode($filelist[$picindex+1]) . "&amp;dispsize=$dispsize&amp;start=$start&amp;picindex=" . ($picindex + 1);
			print "<link rel='next' type='text/html' href='$next_url'>\n";
		}
		
		$end_url = $htmlbase.$viewpath.$userstring."album=" . urlencode($path) . "&amp;pic=" . urlencode($filelist[$totalfiles-1]) . "&amp;dispsize=$dispsize&amp;start=$start&amp;picindex=" . ($totalfiles - 1);
		print "<link rel='end' type='text/html' href='$end_url'>\n";
		
	} else {
		if ($endpoint == $path) {
			print "<link rel='up' type='text/html' href='${htmlbase}${albumpath}${userstring}dispsize=$dispsize'>\n";
		} else {
			print "<link rev='up' type='text/html' href='${htmlbase}${albumpath}${userstring}album=" . urlencode(substr($path,0,strlen($path)-strlen($endpoint)-1)) . "&amp;dispsize=$dispsize&amp;start=$st'>\n";
		}
		
		$thisbase = $htmlbase.$albumpath.$userstring."album=" . urlencode($path) . "&amp;dispsize=$dispsize";

		print "<link rev='first' type='text/html' href='${thisbase}&amp;start=0'>\n";
    	
    	if ($start > 0) {
      		print "<link rev='prev' type='text/html' href='${thisbase}&amp;start=" . max(0, $start - $items_per_page) . "'>\n";
    	}
  		# XXX: Gah, hack, bleh.
    	for ($x = $start; $x < $start + $items_per_page and $filelist[$x]; $x++);
    	if ($totalfiles > $x) {
      		print "<link rel='next' type='text/html' href='${thisbase}&amp;start=$x'>\n";
    	}
    	
    	print "<link rel='end' type='text/html' href='${thisbase}&amp;start=". (floor($totalfiles / $items_per_page) * $items_per_page) ."'>\n";
	}
}

?>
